COMMENT *

         _____                     _____ _     _       _____ 
        /  __ \                   /  __ \ |   (_)     |  _  |
        | /  \/_ __ __ _ _____   _| /  \/ |__  _ _ __  \ V / 
        | |   | '__/ _` |_  / | | | |   | '_ \| | '_ \ / _ \ 
        | \__/\ | | (_| |/ /| |_| | \__/\ | | | | |_) | |_| |
         \____/_|  \__,_/___|\__, |\____/_| |_|_| .__/\_____/
                             __/  |             | |          
                            /___ /              |_|  
                     

            CrazyChip8 is an Chip-8 emulator which uses,
           to run games like: 'pong', 'space Invaders'..etc.
         it emulates the Chip8 only (no SuperChip8 extended).
                     
     - This is a Win32Asm (MASM) Port of the original VC++ Release -
      
             -  Ported/Coded By Bengi/2004 -
             
     Greets:
       Many thanks to the Win32asm.cjb.net Community (members) & RadASM (by KetilO) IDE,
       For thier awsome Contribution and 'online' help.
       Without you guys, 32bit ASM wouldn't be great as it is now.
       Keep on Rocking!                                                
*


.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

;
; INCLUDES
;
include CrazyChip8.inc  ; EMULATOR Definitions
include DirectDraw.inc  ; DDRAW    Definitions
include DirectInput.inc ; DINPUT   Definitions
include Chip8.inc       ; Chip8    Definitions
include Debugger.inc    ; DEBUGGER Definitions

;
; Code Section
;
.code      
      include DirectDraw.asm  ; DirectDraw  Functions
      include DirectInput.asm ; DirectInput Functions
      include Chip8.asm       ; DirectInput Functions
      include Debugger.asm    ; Debugger    Functions

;
; --==============--
; Start of Code here
; --===============--
;      
start:
	invoke GetModuleHandle, NULL ; Get Instance of Program
	mov    hInstance,eax 
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

;
; "EntryPoint" of Program
;
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX	           
	LOCAL msg:MSG
	LOCAL hWnd:HWND
	
	; Register Window
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET g_hWndClass
	invoke LoadIcon,hInst,IDI_CHIP8
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	
	; Check Return Value
	.if !eax
	    invoke MessageBox,NULL,addr Error_msg,addr Error,MB_OK
	    ret
	.endif
	
	mov gHeight,INIT_HEIGHT
	mov gWidth,INIT_WIDTH
	
	;Create our Window
	INVOKE CreateWindowEx,NULL,ADDR g_hWndClass,ADDR CRAZYCHIP8,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,gWidth,gHeight,NULL,NULL,\
           hInst,NULL
          
    ;Check return Value 
    .if !eax 
       invoke MessageBox,NULL,addr Error_msg2,addr Error,MB_OK
       ret
    .endif  
             
    ; Initialize
	mov  hWnd,eax
	mov  g_MainhWnd,eax
	mov  g_hWnd, eax
	mov  FileSize,NULL
	
	;//////////////////////////
    ;// Initalize DirectDraw //
    ;//////////////////////////
    
    ;Create & Initalize The DX COM Object
    invoke DirectDrawInit,hWnd  
    .if (!eax)
        ret
    .endif 
       
    ; Create the DX Surfaces
    invoke CreateDirectDrawSurfaces,FALSE
    .if (!eax)
        ret
    .endif 
       
    ;Create & Initalize The DI COM Object
    invoke DirectInputInit,hInstance
    .if (!eax)
        ret
    .endif
    
    ; Create DI Device(s)
    invoke CreateDirectInputDevice,hWnd
    .if (!eax)
        ret
    .endif        
	
	;Clear the BackSurface		
	invoke DDClear, g_pDDSBack, 0, 0, 480, 320
	;Check if Surfaces are lost
    invoke CheckSurfaces
    invoke DDFlip ; Change Surface's Pointers (Primary<->Back)
    
	;///////////////////////////
	
	invoke ShowWindow, hWnd,SW_SHOWNORMAL
	invoke UpdateWindow, hWnd	
	
	; Initialize Emulator Visualy
	invoke InitEmulator  
	
	mov g_Running,TRUE
	mov EmulatorRunning,FALSE
	
	;///////////////////
	;// Message Pump  //
	;///////////////////
	.WHILE (g_Running==TRUE)
	;{	
	   .if (EmulatorRunning==TRUE)
	       invoke Emulate ; Emulation Process 
	   .endif
	
	   .WHILE ($invoke(PeekMessage,addr msg,g_MainhWnd,0,0,PM_NOREMOVE))
	   ;{
		  invoke GetMessage, ADDR msg,NULL,0,0
		  .IF (!eax)		  
		      mov g_Running,FALSE	
		      .BREAK		      	     		 
		  .ENDIF		  
		  invoke TranslateMessage, ADDR msg
		  invoke DispatchMessage, ADDR msg		  
	   ;}		  
	   .ENDW 
	;}
	.ENDW
		
	;invoke DestroyDirectDrawObjects
	;invoke DestroyDirectInputDevices
	mov     eax,msg.wParam
	ret
WinMain endp

;
; Main Window Procedure, Handled all Messages Sent by Windows on this Window
;
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
     LOCAL rc:RECT
     LOCAL rcMain:RECT
     LOCAL hMenu,hSubMenu:HMENU
     LOCAL hPopUp[2]:HMENU
      
	.IF uMsg==WM_DESTROY
	     mov g_Running,FALSE
	     ; Destroy DX/DI Ojects
	     invoke DestroyDirectInputDevices
         invoke DestroyDirectDrawObjects
		 invoke PostQuitMessage,NULL
		
	.ELSEIF uMsg==WM_CLOSE
         invoke DestroyWindow,hWnd
          
    .ELSEIF uMsg==WM_SIZE
         invoke GetWindowRect,hWnd,addr rc
         invoke GetClientRect,hWnd,addr rcMain
         mov eax,rc.bottom
         sub eax,rc.top
         mov gHeight,eax
         mov eax,rc.right
         sub eax,rc.left
         mov gWidth,eax
         
    .ELSEIF uMsg==WM_CREATE       
          invoke CreateMenu
          mov hMenu,eax
          
          invoke CreatePopupMenu
          mov hSubMenu,eax
          invoke AppendMenu,hSubMenu,MF_STRING,ID_LOAD,offset LOADROM
          invoke AppendMenu,hSubMenu,MF_SEPARATOR,NULL,NULL
          invoke AppendMenu,hSubMenu,MF_STRING,ID_RESET,offset RESETCPU
          invoke AppendMenu,hSubMenu,MF_STRING,ID_PAUSE,offset PAUSE
          invoke AppendMenu,hSubMenu,MF_SEPARATOR,NULL,NULL
          invoke AppendMenu,hSubMenu,MF_STRING,ID_EXIT,offset EXIT
          invoke AppendMenu,hMenu,MF_STRING or MF_POPUP,hSubMenu,offset EMULATION
          
          invoke CreatePopupMenu
          mov hSubMenu,eax
          
          invoke CreatePopupMenu
          mov hPopUp[0],eax
          invoke AppendMenu,hSubMenu,MF_STRING or MF_POPUP,hPopUp[0],offset VIDEO
          invoke AppendMenu,hPopUp[0], MF_STRING, ID_SIZE_X1, offset X1
          invoke AppendMenu,hPopUp[0], MF_STRING, ID_SIZE_X2, offset X2
          invoke AppendMenu,hPopUp[0], MF_STRING, ID_SIZE_X3, offset X3
          invoke AppendMenu,hPopUp[0], MF_STRING, ID_SIZE_X4, offset X4
          
          invoke CreatePopupMenu
          mov hPopUp[1],eax
          invoke AppendMenu,hSubMenu,MF_STRING or MF_POPUP,hPopUp[1],offset SOUND
          invoke AppendMenu,hPopUp[1], MF_STRING, ID_SOUND_ON, offset SOUND_ON
          invoke AppendMenu,hPopUp[1], MF_STRING, ID_SOUND_OFF, offset SOUND_OFF
          invoke AppendMenu,hMenu,MF_STRING or MF_POPUP,hSubMenu,offset OPTIONS
          
          invoke CreatePopupMenu
          mov hSubMenu,eax
          invoke AppendMenu,hSubMenu,MF_STRING,ID_DEBUG,offset DEBUGGER
          invoke AppendMenu,hSubMenu,MF_STRING,ID_CPU_SPEED,offset CPU_SPEED
          invoke AppendMenu,hMenu,MF_STRING or MF_POPUP,hSubMenu,offset TOOLS
          
          invoke CreatePopupMenu
          mov hSubMenu,eax
          invoke AppendMenu,hSubMenu,MF_STRING,ID_ABOUT,offset ABOUT
          invoke AppendMenu,hMenu,MF_STRING or MF_POPUP,hSubMenu,offset HELP
          
          invoke SetMenu,hWnd,hMenu
          
    .ELSEIF uMsg==WM_PAINT
          ;Windowed Mode Only
          .if (!g_bFullScreen)              
              invoke CheckSurfaces
              invoke DDFlip                                    
              invoke ValidateRect,hWnd, NULL
          .endif
          mov eax,FALSE     
          
    .ELSEIF uMsg==WM_COMMAND
          mov eax,wParam
          
          .IF ax==ID_EXIT
              invoke SendMessage,hWnd,WM_CLOSE,0,0
              
          .ELSEIF ax==ID_LOAD
              invoke LoadRom,hWnd
              
          .ELSEIF ax==ID_PAUSE
               .if EmulatorRunning==TRUE
               ;{
                   invoke GetMenu,hWnd
                   mov hMenu,eax
                   
                   .if !PauseCpu                      
                      invoke CheckMenuItem,hMenu,ID_PAUSE,MF_CHECKED
                      mov PauseCpu,TRUE
                   .else
                      invoke CheckMenuItem,hMenu,ID_PAUSE,MF_UNCHECKED
                      mov PauseCpu,FALSE
                   .endif
               ;}    
               .endif
          
          .ELSEIF ax==ID_LOAD
                invoke LoadRom,hWnd
                
          .ELSEIF ax==ID_RESET
                invoke Init_CPU
                
          .ELSEIF ax==ID_DEBUG
                mov PauseCpu,TRUE
                invoke DialogBoxParam,hInstance,IDD_DEBUGGER,NULL,addr DebuggerDlgProc,NULL 
                
          .ELSEIF ax==ID_SIZE_X1
                mov gHeight,INIT_HEIGHT
                mov gWidth,INIT_WIDTH
                invoke GetWindowRect,hWnd,addr rc
                invoke MoveWindow,hWnd,rc.left,rc.top,gWidth,gHeight,TRUE
                
          .ELSEIF ax==ID_SIZE_X2
                mov gHeight,INIT_HEIGHT*2
                mov gWidth,INIT_WIDTH*2
                invoke GetWindowRect,hWnd,addr rc
                invoke MoveWindow,hWnd,rc.left,rc.top,gWidth,gHeight,TRUE
                
          .ELSEIF ax==ID_SIZE_X3
                mov gHeight,INIT_HEIGHT*3
                mov gWidth,INIT_WIDTH*3
                invoke GetWindowRect,hWnd,addr rc
                invoke MoveWindow,hWnd,rc.left,rc.top,gWidth,gHeight,TRUE
                
          .ELSEIF ax==ID_SIZE_X4
                mov gHeight,INIT_HEIGHT*4
                mov gWidth,INIT_WIDTH*4
                invoke GetWindowRect,hWnd,addr rc
                invoke MoveWindow,hWnd,rc.left,rc.top,gWidth,gHeight,TRUE   
                
          .ELSEIF ax==ID_SOUND_ON
                invoke GetMenu,g_MainhWnd
                mov hMenu,eax
                invoke GetSubMenu,hMenu,1
                mov hSubMenu,eax
                invoke GetSubMenu,hSubMenu,1
                mov hSubMenu,eax
                invoke CheckMenuItem,hSubMenu,ID_SOUND_ON,MF_CHECKED
                invoke CheckMenuItem,hSubMenu,ID_SOUND_OFF,MF_UNCHECKED
                mov SoundOn,TRUE
                                
          .ELSEIF ax==ID_SOUND_OFF
                invoke GetMenu,g_MainhWnd
                mov hMenu,eax
                invoke GetSubMenu,hMenu,1
                mov hSubMenu,eax
                invoke GetSubMenu,hSubMenu,1
                mov hSubMenu,eax
                invoke CheckMenuItem,hSubMenu,ID_SOUND_ON,MF_UNCHECKED
                invoke CheckMenuItem,hSubMenu,ID_SOUND_OFF,MF_CHECKED
                mov SoundOn,FALSE
                
          .ELSEIF ax==ID_CPU_SPEED
                invoke DialogBoxParam,hInstance,IDD_CPU_SPEED,NULL,addr CpuSpeedDlgProc,NULL                  
                
          .ELSEIF ax==ID_ABOUT              
              invoke DialogBoxParam,hInstance,IDD_ABOUT,NULL,addr AboutDlgProc,NULL                               
          .ENDIF                          
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	xor eax,eax
	ret
	
WndProc endp

;
; About Dialog
;
AboutDlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    
    mov eax,uMsg
    .if eax==WM_CLOSE
        invoke EndDialog,hWnd,0        
    .else
        mov eax,FALSE	
		ret
    .endif
    
    xor eax,TRUE
    ret

AboutDlgProc endp

;
; Change CPU Speed Dialog
;
CpuSpeedDlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
     LOCAL Speed[20]:BYTE
     
     mov eax,uMsg
    .if eax==WM_CLOSE
        invoke EndDialog,hWnd,0
        
    .elseif eax==WM_INITDIALOG
        MAKELONG 0,60
        invoke SendDlgItemMessage,hWnd,IDC_CPU_SPEED,TBM_SETRANGE,TRUE,eax
        invoke SendDlgItemMessage,hWnd,IDC_CPU_SPEED,TBM_SETPOS,TRUE,ClockSpeed
        invoke wsprintf,addr Speed,offset DecFormat,ClockSpeed
        invoke SetDlgItemText,hWnd,IDC_SPEED_SIZE,addr Speed
         
    .elseif eax==WM_NOTIFY
        mov eax,wParam
        
        .if eax==IDC_CPU_SPEED
            mov ClockSpeed,$invoke(SendDlgItemMessage,hWnd,IDC_CPU_SPEED,TBM_GETPOS,0,0)
            
            .if(!ClockSpeed)
                invoke lstrcpy,addr Speed,offset Fastest
            .elseif ClockSpeed==60
                invoke lstrcpy,addr Speed,offset Slowest
            .else
                mov eax,60
                sub eax,ClockSpeed                
                invoke wsprintf,addr Speed,offset Hertz,eax
            .endif
            
            invoke SetDlgItemText,hWnd,IDC_SPEED_SIZE,addr Speed
                
        .endif
                  
    .elseif eax==WM_COMMAND
        mov eax,wParam
        .if ax==IDC_EXIT_SPEED
            invoke SendMessage,hWnd,WM_CLOSE,0,0
        .endif
          
    .else
        mov eax,FALSE	
		ret
    .endif
    
    xor eax,TRUE
    
    ret
CpuSpeedDlgProc endp

;--==== END OF PROGRAM HERE ====----
end start