DebuggerDlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    
    mov eax,uMsg
    .if eax==WM_CLOSE
        invoke EndDialog,hWnd,0
            
    .elseif eax==WM_INITDIALOG
        .If (FileSize!=NULL)
              invoke CheckMenuItem,$invoke(GetMenu,g_MainhWnd),ID_PAUSE,MF_CHECKED
              invoke ShowDisasm,hWnd
              invoke ShowCPUInformation,hWnd
        .endif 
    
    .elseif eax==WM_COMMAND
        mov eax,wParam ; Get Button ID
        
        .if eax==IDC_OK
            invoke SendMessage,hWnd,WM_CLOSE,0,0
            
        .elseif eax==IDC_STEP_CPU
               .if (FileSize!=NULL) ;There is a loaded file ?
                   invoke CPU_STEP
                   invoke ShowCPUInformation,hWnd
               .endif         
        .endif   
         
    .else
        mov eax,FALSE	
		ret
    .endif
    
    xor eax,TRUE
    ret

DebuggerDlgProc endp


ShowDisasm proc uses eax esi ecx hWnd:HWND
    LOCAL wOpcode:WORD
    LOCAL iIndex:DWORD
    
    invoke SendMessage,$invoke(GetDlgItem,hWnd,IDC_DEBUG_INFO),LB_RESETCONTENT,0,0
    mov iIndex,0    
    
iLoop:
    mov esi,offset Memory
    add esi,200h
    add esi,iIndex
    mXOR eax
    mov al, byte ptr [esi]
    shl eax,8
    add esi,1
    or al,byte ptr [esi]
    mov wOpcode,ax
    invoke DisasmChip8,wOpcode,offset Assembly ; Disassembly Of Opcode
    mov ecx,iIndex
    add ecx,200h
    mXOR eax
    mov ax,wOpcode
    invoke wsprintf,addr Dasm,offset Disasm_Format,ecx,eax,addr Assembly ; Format
    invoke SendMessage,$invoke(GetDlgItem,hWnd,IDC_DEBUG_INFO),LB_ADDSTRING,iIndex,offset Dasm
    add iIndex,2
    mov eax,iIndex
    cmp eax,FileSize
    jb iLoop           
    ret
ShowDisasm endp

ShowCPUInformation proc uses eax ecx hWnd:HWND
    LOCAL mDasm[128]:BYTE   
    
    invoke GetDlgItem,hWnd,IDC_DEBUG_INFO
    mov ecx, CodeIndex
    sub ecx,200h
    shr ecx,1
    invoke SendMessage,eax,LB_SETCURSEL,ecx,NULL
    
    mXOR eax
    mov al,Registers[0]
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V0,addr mDasm
    
    mXOR eax
    mov al,Registers[1]    
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V1,addr mDasm
    
    mXOR eax
    mov al,Registers[2]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V2,addr mDasm
    
    mXOR eax
    mov al,Registers[3]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V3,addr mDasm
    
    mXOR eax
    mov al,Registers[4]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V4,addr mDasm
    
    mXOR eax
    mov al,Registers[5]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V5,addr mDasm
    
    mXOR eax
    mov al,Registers[6]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V6,addr mDasm
    
    mXOR eax
    mov al,Registers[7]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V7,addr mDasm
    
    mXOR eax
    mov al,Registers[8]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V8,addr mDasm
    
    mXOR eax
    mov al,Registers[9]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V9,addr mDasm
    
    mXOR eax
    mov al,Registers[10]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V10,addr mDasm      
    
    mXOR eax
    mov al,Registers[11]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V11,addr mDasm
    
    mXOR eax
    mov al,Registers[12]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V12,addr mDasm
    
    mXOR eax
    mov al,Registers[13]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V13,addr mDasm
    
    mXOR eax
    mov al,Registers[14]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V14,addr mDasm       
    
    mXOR eax
    mov al,Registers[15]      
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_V15,addr mDasm
    
    
    invoke wsprintf,addr mDasm,offset Format,CodeIndex
    invoke SetDlgItemText,hWnd,IDC_PC,addr mDasm
    
    invoke wsprintf,addr mDasm,offset Format,StackPointer
    invoke SetDlgItemText,hWnd,IDC_SP,addr mDasm
    
    invoke wsprintf,addr mDasm,offset Format,RegI
    invoke SetDlgItemText,hWnd,IDC_I,addr mDasm    
    
    mXOR eax
    mov al,SoundTimer
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_TIMER,addr mDasm 
    
    mXOR eax
    mov al,DelayTimer
    invoke wsprintf,addr mDasm,offset Format,eax
    invoke SetDlgItemText,hWnd,IDC_DELAY,addr mDasm 
    
    ret
ShowCPUInformation endp